<?php
	/*
	File Name: status.php
	Author: Łukasz "Rutek" Rutkowski
	Author URI: http://eazu.pl/
	License: GPL2
	*/
	include_once("ventrilostatus.php");
	include_once("process.php");
	include_once("socketserver.php");
	include_once("sockethelper.php");

	class VentriloStatus {
		private $hnd;
	
		private $online;
		private $name;
		private $host;
		private $port;
		private $users;
		private $slots;
		private $dir;
	
		public function __construct($host, $port, $dir) {
			// '/home/rutek/Pulpit/ventrilostatus_php/ventrilo_status'		
			$this->hnd = new CVentriloStatus;
			$this->hnd->m_cmdprog = $dir.'ventrilo_status';
			$this->hnd->m_cmdcode = '2';
			$this->hnd->m_cmdhost = $host;
			$this->hnd->m_cmdport = $port;
			$this->hnd->m_cmdpass = '';
		
			$this->host = $host;
			$this->port = $port;
			$this->dir = $dir;
		}
		private function updateStatus() {		
			$rc = $this->hnd->Request();
			if($rc) {
				// Offline
				$this->online = FALSE;
			} else {
				// Online
				$this->online = TRUE;
				$this->name = $this->hnd->m_name;
				$this->users = $this->hnd->m_clientcount;
				$this->slots = $this->hnd->m_maxclients;
			}
		}
		public function saveBar($serverName) {	
			if(Process::start()) {		
				while(TRUE) {	
					sleep(1);	
					$this->updateStatus();
					$fontText = $this->dir.'font.ttf';
					$fontNumbers = $this->dir.'font_numbers.ttf';
					$bg = 'bg_small.png';
					$img = imagecreatefrompng($bg);
					$txtColor = imagecolorallocate($img, 255, 255, 255);
					$green = imagecolorallocate($img, 0, 255, 0);
					$red = imagecolorallocate($img, 255, 0, 0);
					if($this->online == TRUE) 
					{
						imagefilledrectangle($img, 31, 2, 33, 17, $green);
						imagettftext($img, 6, 0, 36, 8, $txtColor, $fontText, $this->name);
						imagettftext($img, 8, 0, 37, 18, $txtColor, $fontNumbers, $this->host.':'.$this->port);
						imagettftext($img, 8, 0, 180, 13, $txtColor, $fontNumbers, $this->users.'/'.$this->slots);
					}
					else
					{
						imagefilledrectangle($img, 31, 2, 33, 17, $red);
						imagettftext($img, 6, 0, 36, 8, $txtColor, $fontText, $serverName);
						imagettftext($img, 8, 0, 37, 18, $txtColor, $fontNumbers, $this->host.':'.$this->port);
						imagettftext($img, 8, 0, 180, 13, $txtColor, $fontNumbers, '-/-');
					}				
					imagepng($img, 'bar.png', 9);
					imagedestroy($img);	
				}
				Process::end();
			}					
		}	
	}

	class Client extends SocketHelper {
		public function sendStatus($conn) {
			$read = $this->sockRead($conn, 255);
		
			if((file_exists('bar_old.png') AND filesize('bar.png') < (filesize('bar_old.png')*0.75))) {
				usleep(100000);
			}
			$content = file_get_contents('bar.png');
		
			$len = strlen($content);
		
			$header = "HTTP/1.1 200 OK\nConnection: close\nContent-Type: text/png\nContent-Length: ".$len."\nCache-control: must-revalidate\nExpires: ".gmdate ("D, d M Y H:i:s", time() + CACHE_TIME)." GMT\n\n";
			$this->sockWrite($conn, $header.$content);
		}
	}
	$stat = new VentriloStatus('212.59.242.51', '3784', '/home/rutek/Pulpit/ventrilo_status/');
	//$stat = new VentriloStatus('212.59.242.51', '3784', '/home/serwery/ventrilo_status/');
	$stat->saveBar('Strzelaj.net [Ventrilo]');

	$srv = new SocketServer('127.0.0.1', '9090');
	//$srv = new SocketServer('212.59.242.51', '9090');
	$srv->bindConn('Client', 'sendStatus');
	while(TRUE) {
		sleep(120);
	}
